<template>
    <div class="space_between">
        <div v-show='!phone_is_valid' class="space_between">
			<div>
				<div class="titles two_rows">
					<div class="block-title active">{{$t('message.reset_password')}}</div>
				</div>

				<a @click="$router.go(-1)" class="back_arrow">
					<svg width="44" height="35" viewBox="0 0 44 35" fill="none" xmlns="http://www.w3.org/2000/svg">
						<g>
							<rect x="16.9712" y="0.712891" width="2" height="23.3212" transform="rotate(45 16.9712 0.712891)"/>
							<rect y="17.707" width="2" height="23.9822" transform="rotate(-45 0 17.707)"/>
							<rect x="2.37598" y="18.7617" width="2" height="41" transform="rotate(-90 2.37598 18.7617)"/>
						</g>
					</svg>
				</a>

				<div class="input_container second">
					<!-- <input
						id='phone'
						type='text'
						v-on:blur='handle_phone_input_blur'
						v-model='phone'
					> -->
					<form @submit.prevent="send_phone" style="display: flex; width: 100%">
<!--						<the-mask-->
<!--                            name="phone"-->
<!--                            autocomplete="phone"-->
<!--							:mask="['+38 (0##) ###-##-##']"-->
<!--							type="text"-->
<!--							v-bind:placeholder="$t('message.enter_phone_number')"-->
<!--							v-model='phone'-->
<!--							v-on:input='check_phone'-->
<!--						></the-mask>-->
                        <div class="input_component fix-margin">
                            <v-text-field
                                name="phone"
                                autocomplete="phone"
                                type="text"
                                :placeholder="$t('message.phone_placeholder')"
                                :class="[error ? 'error' : '']"
                                v-mask="mask"
                                @input="check_phone"
                                @focus="initMask"
                                v-model='phone'
                            >
                                <template slot="label">{{$t('message.phone_placeholder')}}</template>
                            </v-text-field>
                        </div>
					</form>
				</div>

                <div class="message error" v-if="!phone_is_valid">
                    {{phone_err_msg}}
                </div>

                <div v-if="phone_is_unknown">
                    <div class="message error">{{$t('message.unknown_phone')}}</div>
                    <router-link to="/register" class="message link">{{$t('message.please_register')}}</router-link>
                </div>
			</div>


			<div class="buttons">
				<button
					@click='send_phone'
					type='submit'
					:disabled='!phone_is_enough || isLoading'
					class="btn enter"
				>{{$t('message.send_sms')}}</button>
			</div>
        </div>

        <div v-show='phone_is_valid && !code_is_valid' class="space_between">
			<div>
				<div class="titles">
					<div class="block-title active">{{$t('message.reset_password')}}</div>
				</div>

				<a @click="change_phone_before_validation" class="back_arrow">
					<svg width="44" height="35" viewBox="0 0 44 35" fill="none" xmlns="http://www.w3.org/2000/svg">
						<g>
							<rect x="16.9712" y="0.712891" width="2" height="23.3212" transform="rotate(45 16.9712 0.712891)"/>
							<rect y="17.707" width="2" height="23.9822" transform="rotate(-45 0 17.707)"/>
							<rect x="2.37598" y="18.7617" width="2" height="41" transform="rotate(-90 2.37598 18.7617)"/>
						</g>
					</svg>
				</a>

				<div>
					<div class="input_container second">
                        <div class="input_component fix-margin">
                            <input
                                id='code'
                                type='text'
                                v-model='code'
                                :placeholder="$t('message.check_your_phone')"
                                :class="[error ? 'error' : '']"
                                @keyup.enter="send_code"
                                autocomplete="off"
                            >
                            <div class="lbl">{{$t('message.check_your_phone')}}</div>
                        </div>
					</div>

                    <div class="message">{{$t('message.sent_sms')+phone}}</div>

					<div
						v-if="after_timeout"
						v-on:click='send_phone'
						class="message"
					><span class="link">{{$t('message.code_again')}}</span></div>

					<div v-if="error" class="message error">{{$t('message.code_error')}}</div>
				</div>
			</div>

			<div class="buttons">
				<button
					v-on:click='send_code'
					type='submit'
					class="btn enter"
				>{{$t('message.continue')}}</button>
			</div>
        </div>

        <div v-show='phone_is_valid && code_is_valid' class="space_between">
<!--		<div v-show='!phone_is_valid' class="space_between">-->
			<div>
				<div class="titles">
					<div class="block-title active">{{$t('message.reset_password')}}</div>
				</div>

				<a @click="$router.go(-1)" class="back_arrow">
					<svg width="44" height="35" viewBox="0 0 44 35" fill="none" xmlns="http://www.w3.org/2000/svg">
						<g>
							<rect x="16.9712" y="0.712891" width="2" height="23.3212" transform="rotate(45 16.9712 0.712891)"/>
							<rect y="17.707" width="2" height="23.9822" transform="rotate(-45 0 17.707)"/>
							<rect x="2.37598" y="18.7617" width="2" height="41" transform="rotate(-90 2.37598 18.7617)"/>
						</g>
					</svg>
				</a>

				<div class="input_container">
                    <div class="input_component fix-margin">
                        <input
                            id='password'
                            type='password'
                            v-model='password'
                            v-bind:placeholder="$t('message.create_password')"
                            :class="(password_errors.password || password_errors.c_password) ? 'error' : ''"
                            @keyup.enter="send_password"
                        >
                        <div class="lbl">{{$t('message.create_password')}}</div>
                    </div>
				</div>

				<div class="input_container second">
                    <div class="input_component fix-margin">
                        <input
                            id='c_password'
                            type='password'
                            v-model='c_password'
                            v-bind:placeholder="$t('message.confirm_password')"
                            :class="(password_errors.password || password_errors.c_password) ? 'error' : ''"
                            @keyup.enter="send_password"
                        >
                        <div class="lbl">{{$t('message.confirm_password')}}</div>
                    </div>
				</div>

				<div v-if="password_errors.password || password_errors.c_password" class="message error">{{password_errors.password[0] || password_errors.c_password[0]}}</div>
			</div>

			<div class="buttons">
				<button
					v-on:click='send_password'
					type='submit'
					class="btn enter"
				>{{$t('message.continue')}}</button>
			</div>
        </div>
		<div v-if="isLoading" class="animation-container">
			<lottie :options="defaultOptions" :height="100" :width="100"/>
		</div>
    </div>
</template>

<script>
    import {mask} from 'vue-the-mask';
    import Lottie from 'vue-lottie';
    import * as animationData from "./animation/preload.json";

    export default {
        directives: {
            mask,
        },
        components: {
            'lottie': Lottie
        },
        data: () => {
            return {
                // phone: '',
                code: null,
                // phone_is_enough: false,
                password: null,
                c_password: null,
				after_timeout: false,
	            error: '',
	            code_is_valid: null,
                mask: '+38 (0##) ###-##-##',
                isLoading: false,
                defaultOptions: {animationData: animationData.default},
            }
        },
        methods: {
            async send_phone () {
                this.isLoading = true;
                this.after_timeout = false;

                const {data} = await axios.post('/forgot', {phone: this.phone});

                if(data.is_unknown) {
                    this.$store.commit('set_phone_err_msg', data.unknown);
                }
                if(!data.is_valid) {
                    this.$store.commit('set_phone_err_msg', data[0].phone[0]);
                }
                this.$store.commit('set_phone_status', data.is_valid);

                this.isLoading = false;
	            setTimeout(() => {this.after_timeout = true}, 30000);
            },
            async send_code () {
                const {data} = await axios.post('/register/validate_code', {
                    code: this.code,
                    phone: this.phone
                });

                if(!data.is_valid){
                    this.error = 1;
                }
                this.code_is_valid = data.is_valid;
            },
            async send_password () {
                const {data} = await axios.post('/profile/change_password', {
                    password: this.password,
                    c_password: this.c_password
                });

                if(data[0]) {
                    this.$store.commit('set_password_err', data[0])
                }
                else {
                    this.$router.push('/profile');
                }
                this.$store.commit('set_password_status', data.is_valid);
            },
            check_phone () {
                this.error = '';
            },
            change_phone_before_validation () {
                this.$store.dispatch('reset_phone', null)
            },
            initMask () {
                this.phone = this.phone.length < 6 ? '+38 (0' : this.phone;
            }
        },
        computed: {
            phone: {
                set: function(n){this.$store.dispatch('set_phone', n)},
                get: function(){return this.$store.getters.phone},
            },
            phone_is_valid: function () {
                return this.$store.getters.phone_is_valid;
            },
            phone_is_unknown: function () {
                return this.$store.getters.phone_is_unknown;
            },
            phone_err_msg: function () {
                return this.$store.getters.phone_err_msg;
            },
            password_is_valid: function () {
                return this.$store.getters.password_is_valid;
            },
	        password_errors: function () {
		        return this.$store.getters.password_errors;
	        },
            phone_is_enough: function () {
                return this.phone.length == 19;
            }
        }
    }
</script>
